#ifndef MAIN_DIALOG_H
#define MAIN_DIALOG_H

#include <QDialog>

namespace Ui
{
class MainDialog;
}

class MainDialog : public QDialog
{
    Q_OBJECT

public:
    explicit MainDialog(QWidget *parent = nullptr);
    ~MainDialog();

private slots:
    void chl_select();
    void check_bl();
    void check_br();
    void check_tl();
    void check_tr();

    void check_clpout();
    void clpout_offset_change(int new_value);
    void clpout_width_change(int new_value);

private:
    Ui::MainDialog *ui;

    uint32_t bl_value;
    uint32_t br_value;
    uint32_t tl_value;
    uint32_t tr_value;

    QVector<QPushButton *> bl_row;
    QVector<QPushButton *> br_row;
    QVector<QPushButton *> tl_row;
    QVector<QPushButton *> tr_row;
};

#endif // MAIN_DIALOG_H
