/*!
 * @file fpga_io.h
 * @brief This is the header file for FPGA I/O functions.
 *
 * Copyright 2012 (c) Fastec Imaging as an unpublished work.
 * All Rights Reserved.
 *
 * The information contained herein is confidential property of
 * Fastec Imaging. The use, copying, transfer or disclosure of such
 * information is prohibited except by express written agreement
 * with Fastec Imaging.
 */

#ifndef __FPGA_IO_H__
#define __FPGA_IO_H__

// Need to get the FI_IMAGE_ACCESS structure.
#include <fastec/fi_ioctl.h>

bool fpga_io_init( void );
void fpga_io_shutdown( void );
bool fpga_write_reg( uint32_t reg_addr, uint32_t value );
bool fpga_read_reg( uint32_t reg_addr, uint32_t *value );
bool fpga_readwait_reg( uint32_t status_reg, uint32_t mask, uint32_t ok_value, uint32_t reg_addr, uint32_t *value );
bool fpga_modify_reg( uint32_t reg_addr, uint32_t value, uint32_t mask );
bool fpga_read_imfifo(uint8_t *imfifo_buffer, int byte_count);
bool fpga_set_bit( uint32_t reg_addr, uint32_t value );
bool fpga_clear_bit( uint32_t reg_addr, uint32_t value );

bool fpga_get_image(FI_IMAGE_ACCESS *im_access);

#endif /* !__FPGA_IO_H__ */
