/*
 * poke utility - for those who remember the good old days!
 * 
 */

#include <stdint.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <getopt.h>
#include <errno.h>
#include <time.h>
#include <malloc.h>

// For non-stdio
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include <fastec/fi_fpga_regs.h>

#include "fpga_io.h"
#include "fi_log.h"

void usage(char *prog)
{
    printf("usage: %s ADDR VAL\n",prog);
    printf("\n");
    printf("ADDR and VAL may be specified as hex values\n");
}

int main(int argc, char *argv[])
{
    uint32_t reg_addr;
    uint32_t reg_value;

    if (argc!=3)
    {
	usage(argv[0]);
	exit(-1);
    }

    // Initialize our access.
    if (!fpga_io_init())
    {
	perror(argv[0]);
	exit(-1);
    }

    // Get the info from the user data.
    reg_addr = strtoul(argv[1],NULL,0);
    reg_value = strtoul(argv[2],NULL,0);
    if (!fpga_write_reg(reg_addr, reg_value))
	perror(argv[0]);

    // All done.
    fpga_io_shutdown();
    return 0;
}
